#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#if defined(__DJGPP__)
#error DEMO_3 not for djgpp
#endif

#if defined(__HIGHC__)
  #include <dos.h>
  #pragma Offwarn(572)

#elif defined(__WATCOMC__)
  #include <dos.h>

#else
  #include <pldos32.h>
#endif

#include <exc.h>

char progName [_MAX_PATH];

void Execute (const char *path, const char *args)
{
  union REGS regs;
  EXEC_BLK   blk;
  char       buf[150], len;
  ULONG      minPages, maxPages;

  _dx_cmem_limit (4, &minPages, &maxPages);

  strcpy (buf+1, args);
  len = strlen (args);
  buf[0]   = len++;
  buf[len] = 13;

  blk.ex_eseg = 0;              /* inherit environment  */
  blk.ex_coff = (UCHAR*)&buf;   /* command line address */
  blk.ex_cseg = SS_DATA;

#ifdef __WATCOMC__
  regs.w.ax = 0x4B00;
  regs.w.bx = (UINT)&blk;
  regs.w.dx = (UINT)path;
  int386 (0x21, &regs, &regs);
#else
  regs.x.ax = 0x4B00;
  regs.x.bx = (UINT)&blk;
  regs.x.dx = (UINT)path;
  int86 (0x21, &regs, &regs);
#endif

  if (regs.x.cflag & 1)
     printf ("Cannot execute child. Error-code %X\n", regs.h.al);
}

void PostMortemHook (excReg *r)
{
  char buf[150];

  sprintf (buf, " /c echo g %x | 386debug -nobanner %s",
           r->EIP, progName);
  Execute (getenv("COMSPEC"), buf);
  exit (1);
}

int RunningUnder_386debug (void)
{
  FARPTR iv, ex;

  _dx_pmiv_get (13, &iv);
  _dx_excep_get(13, &ex);
  if (FP_SEL(iv) != FP_SEL(ex)) /* separate exc-13 gates ? */
     return (1);                /* yes, debugger active    */
  return (0);
}

int main (int argc, char **argv)
{
  if (!RunningUnder_386debug())
  {
    strcpy (progName, argv[0]);
    InstallExcHandler (PostMortemHook);
  }

 /* Causes a crash, exception handler executes 386|debug and causes
  * a new exception 13 here
  */

  *((char*)-1) = 0;
  return (0);
}

